<template>
  <div class="fluid">
    <label>Телефон&nbsp;
      <span class="red">*</span>
      <div class="question">
        <div
          class="button"
          v-tooltip="{
            classes: 'tooltip kit white',
            trigger: 'hover',
            offset: '4',
            placement: 'right',
            html: 'true',
            content: hint,
        }"/>
      </div>
    </label>
    <div
      v-for="(phone, index) in value"
      :key="index"
      style="flex-direction: column;"
      class="three fields">
      <div class="field connection">
        <AppInputPhone
          :value="phone.model.phone"
          :composite="composite"
          :phone="phone"
          :options="phoneOptions"
          :has-validate="isSend"
          @input="changeItem(index, $event)"/>
        <div class="ui input comment">
          <input
            v-model="phone.model.comment"
            type="text"
            placeholder="Комментарий">
        </div>
        <button
          class="ui button blue small"
          :class="{ disabled: disableConfirmedButton(phone) }"
          v-tooltip.ios="phoneTooltip(phone)"
          @click="confirmedPhoneNumber(phone)">
          <!--          {{ phone.model.phoneIsConfirmed ? 'Подтверждено' : 'Подтвердить' }}-->
          Подтвердить
        </button>
        <button
          v-if="index > 0"
          @click.stop.prevent="deleteItem(index)"
          class="button-delete"/>
        <div
          v-show="phone.model.phoneIsConfirmed"
          v-tooltip.ios="phoneConfirmedTooltip"
          class="phone-confirmed">
          <img
            svg-inline
            src="~/assets/svg/icons/confirmed.svg"
            alt="иконка подтверждения">
        </div>
        <div
          v-show="phone.isSet"
          v-tooltip.ios="informationTooltip"
          class="phone-information">
          <img
            svg-inline
            src="~/assets/svg/icons/info.svg"
            alt="иконка информации">
        </div>
      </div>
      <div class="field flexline">
        <button
          v-if="value.length < 5 && value.length === (index + 1)"
          @click="addItem(index)"
          class="ui button transparent small add-phone">
          + Добавить телефон
        </button>
      </div>
    </div>
    <verify-phone
      v-model="verifyModal"
      :is-counting="phoneCountDownStarted"
      :error-message="error.confirmPhoneNumber"
      @input="confirmVerifyCode($event)"
      @sendAgain="onSendAgain"
      @timeIsUp="onPhoneNumberConfirmedState"
      @close="closePhoneVerify"/>
  </div>
</template>

<script>
import { get } from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import { SHOW } from '~/assets/js/store/infoModal/action-types';
import VerifyPhone from '~/components/redesign/cabinet/modal/verify-phone';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import Phone from '~/assets/js/model/phone/phone';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
export default {
  name: 'AddPhone',
  components: {
    AppInputPhone,
    VerifyPhone,
  },
  props: {
    type: {
      type: String,
      default: '',
    },
    additionalInformationRequest: {
      type: Object,
      default() { return {}; },
    },
    hint: {
      type: String,
      default: '',
    },
    value: {
      type: Array,
      required: true,
      default() {
        return [new Phone()];
      },
    },
    isSend: {
      type: Boolean,
      default: false,
    },
    composite: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      phoneOptions: {
        noIcon: true,
        validationRule: {
          isRequired: true,
          isMobile: true,
          isUnique: true,
        },
        hasAppPhone: true,
        additionalInformationRequest: this.additionalInformationRequest,
      },
      phoneCountDownStarted: false,
      verifyModal: false,
      error: {
        confirmPhoneNumber: '',
      },
      requestToConfirm: {},
      hasRequestToConfirmPhoneNumber: false,
      phoneConfirmedTooltip: {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
        content: `<div style='text-align: center'>
                    Номер телефона подтвержден
                  </div>`,
      },
      informationTooltip: {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
        content: `<div style='text-align: center'>
                    Свяжитесь с вашим менеджером или по телефону ${this.$config.contacts.info.phone}
                  </div>`,
      },
    };
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    async confirmedPhoneNumber(phone) {
      if (this.disableConfirmedButton(phone)) {
        return;
      }

      this.hasRequestToConfirmPhoneNumber = true;

      if (this.phoneCountDownStarted) {
        this.showVerifyPhoneModal();
        return;
      }

      try {
        const data = await this.requestToConfirmPhoneNumber(phone);

        if (data && data.success) {
          this.showVerifyPhoneModal();
          this.phoneCountDownStarted = true;
        }
      } catch (e) {
        console.error(e);
        this.hasRequestToConfirmPhoneNumber = false;
      }
    },
    async requestToConfirmPhoneNumber(phone) {
      this.requestToConfirm = phone;

      const payload = Object.assign({}, this.getRequestPayloadByType(), {
        phoneId: Number(phone.model.phoneId),
      });

      try {
        const { data } = await this.$axios.$post(`/_main/${this.type}/sendPhoneToConfirm`, payload);
        return data;
      } catch (error) {
        this.hasRequestToConfirmPhoneNumber = false;

        if (error.response.status === 502) {
          this.showVerifyPhoneModal();
          this.phoneCountDownStarted = true;
          this.hasRequestToConfirmPhoneNumber = false;
          return false;
        }

        if (!this.verifyModal) {
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
        } else {
          // this.phoneError = error.response.data.message;
        }
      }

      return false;
    },
    async confirmVerifyCode(code) {
      const payload = Object.assign({}, this.getRequestPayloadByType(), {
        code,
        phoneId: Number(get(this.requestToConfirm, 'model.phoneId', '')),
      });

      try {
        const { data } = await this.$axios.$post(`/_main/${this.type}/phoneConfirm`, payload);

        if (data && data.success) {
          this.verifyModal = false;
          this.hasRequestToConfirmPhoneNumber = false;
          this.value.forEach((phone) => {
            if (phone.model.phoneId === this.requestToConfirm.model.phoneId) {
              phone.model.phoneIsConfirmed = true;
            }
          });
        }
      } catch (error) {
        if (error.response.status === 500) {
          this.verifyModal = false;
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
          return;
        }

        this.error.confirmPhoneNumber = get(error, 'response.data.message', '');
        console.error(error.response.data.message);
      }
    },
    onSendAgain() {
      this.confirmedPhoneNumber(this.requestToConfirm);
    },
    addItem(index) {
      const phones = [...this.value];
      const phone = new Phone();
      phone.model.position = index + 1;
      phones.push(phone);
      this.$emit('input', phones);
    },
    deleteItem(index) {
      const newItem = [...this.value];
      newItem.splice(index, 1);
      this.$emit('input', newItem);
    },
    changeItem(index, newPhone) {
      const phones = [...this.value];

      if (newPhone === '') {
        phones[index].model.phone = newPhone;
        this.$emit('input', phones);
      } else {
        newPhone.hasChange = true;
        newPhone.model.phoneIsConfirmed = false;

        newPhone.isDuplicate = this.hasDuplicate(newPhone.model, index);

        phones[index] = newPhone;

        this.$emit('input', phones);
      }
    },
    phoneTooltip(phone) {
      if (!this.disableConfirmedButton(phone)
        || phone.model.phoneIsConfirmed
        || !phone.isValid
        || !phone.model.phone) {
        return {};
      }

      return {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '64',
        html: 'true',
        content: `<div style='text-align: center'>${this.getTooltipContentByIndex(phone)}</div>`,
      };
    },
    getTooltipContentByIndex(phone) {
      const content = [];

      if (phone && phone.hasChange) {
        content.push('Подтверждение возможно только после сохранения изменений');
      }
      if (phone && !phone.hasChange && !phone.isMobile) {
        content.push(`Подтверждение возможно через вашего менеджера или по
          телефону ${this.$config.contacts.info.phone}`);
      }

      return content.join('');
    },
    showVerifyPhoneModal() {
      this.verifyModal = true;
    },
    onPhoneNumberConfirmedState() {
      this.hasRequestToConfirmPhoneNumber = false;
      this.phoneCountDownStarted = false;
    },
    closePhoneVerify() {
      this.hasRequestToConfirmPhoneNumber = false;
      this.verifyModal = false;
    },
    disableConfirmedButton(phone) {
      return (phone && phone.model)
        && (phone.model.phoneIsConfirmed
        || phone.hasChange
        || !phone.isMobile
        || this.hasRequestToConfirmPhoneNumber
        || phone.isDuplicate);
    },
    hasDuplicate(phone, index) {
      if (!phone) {
        return false;
      }

      return this.value
        .filter((item, i) => item.isValid && i !== index)
        .map(phoneItem => phoneItem.model.phone)
        .includes(phone.phone);
    },
    getRequestPayloadByType() {
      return this.type === 'shop'
        ? { shopId: get(this.additionalInformationRequest, 'shopId', null) }
        : { stoId: get(this.additionalInformationRequest, 'stoId', null) };
    },
  },
};
</script>

<style scoped lang="scss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;
        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .flexline {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: center;
  }

  .button-delete {
    position: absolute;
    right: -32px;
    display: block;
    width: 2rem;
    height: 2rem;
    outline: none;
    border: none;
    box-shadow: none;
    border-radius: 0.25rem;
    background-color: #728896;
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.8125rem auto;
    background-image: url('data:image/svg+xml;base64,PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0idXRmLTgiPz4KPHN2ZyBjbGFzcz0ic3ZnLWZpbGwiIGZpbGw9IiNmZmZmZmYiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgeG1sbnM6eGxpbms9Imh0dHA6Ly93d3cudzMub3JnLzE5OTkveGxpbmsiIHg9IjBweCIgeT0iMHB4IgoJIHZpZXdCb3g9IjAgMCAxMiAxNCIgc3R5bGU9ImVuYWJsZS1iYWNrZ3JvdW5kOm5ldyAwIDAgMTIgMTQ7IiB4bWw6c3BhY2U9InByZXNlcnZlIj4KCjxyZWN0IHg9IjciIHk9IjUiIHdpZHRoPSIxIiBoZWlnaHQ9IjYiLz4KPHJlY3QgeD0iNCIgeT0iNSIgd2lkdGg9IjEiIGhlaWdodD0iNiIvPgo8cGF0aCBkPSJNMTIsMkg4LjVWMS41QzguNiwwLjcsOCwwLjEsNy4yLDBINC44QzQsMC4xLDMuNCwwLjcsMy41LDEuNVYySDB2MWgxdjguNUMxLDEyLjksMi4xLDE0LDMuNSwxNAoJaDVjMS40LDAsMi41LTEuMSwyLjUtMi41VjNoMVYyeiBNNC41LDEuNUM0LjUsMS4yLDQuNywxLDQuOCwxaDIuNGMwLjEsMCwwLjMsMC4yLDAuMywwLjVWMmgtM1YxLjV6IE0xMCwxMS41YzAsMC44LTAuNywxLjUtMS41LDEuNQoJaC01QzIuNywxMywyLDEyLjMsMiwxMS41VjNoOFYxMS41eiIvPgo8L3N2Zz4K');
    cursor: pointer;
    transition: 0.1s ease background-color;
    &:hover {
      background-color: #345A81;
    }
  }

  .ui.button.add-phone {
    width: auto;
    margin: auto auto 0 0;
  }

  .ui.form .field > label {
    margin: 0.25rem 0 0.375rem 0;
  }

  .ui.input.icon {
    width: 14rem !important;
    margin-right: 0.875rem;
  }

  .fields.basic-phone {
    .ui.button.add-phone {
      margin: 2.125rem auto auto 0;
    }
    .field.comment {
      width: calc(100% - 10rem - 0.875rem) !important;
    }
  }

  .fluid {
    width: 100% !important;
  }

  .fields,
  .fluid {
    label {
      margin-bottom: 0;
      margin-top: .2rem;
      font-weight: 500;
    }
    .error.message {
      padding: 0.7rem 0 0.2rem 1.8em !important;
    }
    label > span:not(.red) {
      color: inherit;
    }
  }

  .fields > .fields {
    margin: 0;
  }

  .field.connection {
    position: relative;
    display: flex;
    flex-flow: row wrap;
    padding-top: 0.5rem;
    .ui.input.comment {
      width: calc(100% - 13.5rem - 1.75rem) !important;
      margin-top: .75rem;
      margin-right: 0;
    }
  }
  .error.message {
    padding: 0em 0 0.8rem 1em !important;
  }
  .empty-value {
    margin-bottom: 0 !important;
    & + .error.message {
      padding: 0em 0 0.8rem 1em !important;
    }
  }

  .ui.form .three.fields > .field,
  .ui.form .three.fields > .fields {
    width: 40% !important;
  }

  .phone-confirmed {
    position: absolute;
    top: calc(50% - 7.5px);
    right: -200px;
    height: 25px;
  }

  .phone-information {
    position: absolute;
    top: 12px;
    right: -234px;
    height: 25px;

    & > svg {
      width: 24px;
      height: 25px;
      fill: #e13c3c;
    }
  }

  .ui.button.blue.small {
    position: absolute;
    right: -124px;

    &.disabled {
      pointer-events: auto!important;

      &:hover {
        background-color: #4272a4;
      }
    }

    + .button-delete {
      right: -162px;
    }
  }
</style>
